require 'openssl'

class RemiSigner
  attr_reader :secret

  def initialize(secret)
    @secret = secret
  end

  def sign(params)
    hmac = OpenSSL::HMAC.new(secret, OpenSSL::Digest::SHA512.new)
    hmac.update(self.class.stringize params).to_s
  end

  def self.stringize(object)
    case object
    when Hash
      keys = object.keys.sort_by(&:to_s)
      keys.map{|k| "#{k}=#{stringize(object[k])}"}.join('&')
    when Array
      if object.empty?
        nil
      else
        object.map{|v| "#{stringize(v)}"}.join(',')
      end
    else
      object
    end
  end
end

require_relative "remi_signer/version"
